/*!
 * Built by Revolist
 */
'use strict';

const HEADER_SLOT = 'header';
const FOOTER_SLOT = 'footer';
const CONTENT_SLOT = 'content';
const DATA_SLOT = 'data';
/** Receive last visible in viewport by required type */
function getLastCell(data, rowType) {
  return {
    x: data.viewports[data.colType].store.get('realCount'),
    y: data.viewports[rowType].store.get('realCount'),
  };
}

/**
 * Dispatch custom event to element
 */
function dispatch(target, eventName, detail) {
  const event = new CustomEvent(eventName, {
    detail,
    cancelable: true,
    bubbles: true,
  });
  target === null || target === void 0 ? void 0 : target.dispatchEvent(event);
  return event;
}

exports.CONTENT_SLOT = CONTENT_SLOT;
exports.DATA_SLOT = DATA_SLOT;
exports.FOOTER_SLOT = FOOTER_SLOT;
exports.HEADER_SLOT = HEADER_SLOT;
exports.dispatch = dispatch;
exports.getLastCell = getLastCell;
