/*!
 * Built by Revolist
 */
'use strict';

const debounce = require('./debounce-f50730b6.js');
const consts = require('./consts-0082e18b.js');

/** `Object#toString` result references. */
var stringTag = '[object String]';

/**
 * Checks if `value` is classified as a `String` primitive or object.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a string, else `false`.
 * @example
 *
 * _.isString('abc');
 * // => true
 *
 * _.isString(1);
 * // => false
 */
function isString(value) {
  return typeof value == 'string' ||
    (!consts.isArray_1(value) && debounce.isObjectLike_1(value) && debounce._baseGetTag(value) == stringTag);
}

var isString_1 = isString;

exports.isString_1 = isString_1;
